-- HEX value to 7 segment converter
-- by ILoveSpeccy, 18.04.2009

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity hex2seven is
   port 
   (
      input  : in    std_logic_vector(4 downto 0);
      output : out   std_logic_vector(6 downto 0));
end hex2seven;

architecture rtl of hex2seven is

begin

process (input)
begin
   case input is
      when "00000"   => output <= "1000000"; -- 0
      when "00001"   => output <= "1111001"; -- 1
      when "00010"   => output <= "0100100"; -- 2
      when "00011"   => output <= "0110000"; -- 3
      when "00100"   => output <= "0011001"; -- 4
      when "00101"   => output <= "0010010"; -- 5
      when "00110"   => output <= "0000010"; -- 6
      when "00111"   => output <= "1111000"; -- 7
      when "01000"   => output <= "0000000"; -- 8
      when "01001"   => output <= "0011000"; -- 9
      when "01010"   => output <= "0001000"; -- A
      when "01011"   => output <= "0000011"; -- B
      when "01100"   => output <= "1000110"; -- C
      when "01101"   => output <= "0100001"; -- D
      when "01110"   => output <= "0000110"; -- E
      when "01111"   => output <= "0001110"; -- F
      when "10000"   => output <= "1111111"; -- empty
      when "10001"   => output <= "1100011"; -- DOWN
      when "10010"   => output <= "1011100"; -- UP      
      when others => output <= "1111111";
   end case;
end process;

end rtl;
